@echo off
cls

REM *****************************************************************
REM **
REM **  Usage:  filename.bat "Title of video" "InputSource.ext" "InputSubtitles.ext"
REM **
REM *****************************************************************


REM ** 
REM ** Configuration here...
REM ** 


REM ** Note: if VideoToMKV supplied a bitrate, then use that, otherwise use the defaults here
IF "%V2MKV_VBitrate%" == "" ( SET V2MKV_VBitrate=1400k )
IF "%V2MKV_ABitrate%" == "" ( SET V2MKV_ABitrate=256k )
SET FFApp=ffmpeg.exe
SET FFVideo=-vcodec libxvid -b %V2MKV_VBitrate% -r 23.97 -g 250 -coder 0 -level 13
SET FFAudio=-acodec libfaac -ab %V2MKV_ABitrate% -ar 48000 -ac 2
REM ** Note: you can use this to limit the duration of transcoding for testing/debugging purposes
REM SET FFMaxTime=-t 60
SET FFHeaderInfo=-title %1 -author "Peter Souza IV" -copyright "VideoToMKV" -comment "Encoded with ffmpeg."

SET MKVApp="mkvmerge.exe"
REM ** Note: if MKVMerge utilities have been installed, use that version instead of the one supplied with VideoToMKV
IF EXIST "%ProgramFiles%\MKVtoolnix\mkvmerge.exe" ( SET MKVApp="%ProgramFiles%\MKVtoolnix\mkvmerge.exe" )
IF EXIST "%ProgramFiles(x86)%\MKVtoolnix\mkvmerge.exe" ( SET MKVApp="%ProgramFiles(x86)%\MKVtoolnix\mkvmerge.exe" )
SET MKVlang=eng
REM ** Note: MKVLangList, MKVSubList, and MKVSubOrder are set from VideoToMKV directly


REM ** 
REM ** Conversion process here...
REM ** 


REM ** Convert original video/audio file to compressed video/audio format
START "FFMPEG Encoder" /B /LOW /WAIT %FFApp% -y -i %2 %FFHeaderInfo% %FFAudio% %FFVideo% %1.mp4

REM ** Determine if we're muxing subtitle streams
IF "%MKVSubList%" == "" ( GOTO NoSubs )
IF EXIST %3 GOTO DoSubs
GOTO NoSubs

:NoSubs
REM ** Stuff compressed video/audio file into an MKV container without subtitles
START "MKVMerge Encoder" /B /LOW /WAIT %MKVApp% -o %1.mkv --language 1:%MKVlang% --language 2:%MKVlang% -a 2 -d 1 -S %1.mp4 --track-order 0:1,0:2
GOTO CleanUp

:DoSubs
REM ** Stuff compressed video/audio file into an MKV container with subtitles
START "MKVMerge Encoder" /B /LOW /WAIT %MKVApp% -o %1.mkv --language 1:%MKVlang% --language 2:%MKVlang% -a 2 -d 1 -S %1.mp4 %MKVLangList% %MKVSubList% -D -A %3 --track-order 0:1,0:2%MKVSubOrder%

:CleanUp
REM ** Delete temporary video/audio file
DEL %1.mp4
